<?php
//UTF-8 ěščřžýáíéďťňó//
//------------------------------------------------------------------------------
/**
 * gets time stamp - for speed measurement
 */
function getmicrotime() {
  list($usec, $sec) = explode(" ",microtime());
  return ((float)$usec + (float)$sec);
}
//------------------------------------------------------------------------------
/**
 * prints message
 * @param $msg - message
 */
function classification_msg($msg) {
  echo '<div style="border: 1px solid silver">'.$msg.'</div>' ;
}
//------------------------------------------------------------------------------
/**
 * prints debug message using print_r and <pre>
 * @param $msg - message
 */
function dmsg($msg) {
  echo '<div style="border: 1px solid silver"><pre>'.print_r($msg,true).'</pre></div>' ;
}
//------------------------------------------------------------------------------
/**
 * loads file and returns its content and length
 * @param $fn - filename
 */
function load_file($fn) {
  if(!file_exists($fn)) {
    classification_msg("soubor $fn neexistuje");
    return;
    }

  $size=filesize($fn);

  if(!($f=fopen($fn,'rb'))) {
    classification_msg("soubor $fn nejde otevrit");
    return;
    }

  $content=fread($f,$size);

  if($content===false) {
    classification_msg("soubor $fn se nepodarilo nacist");
  }

  fclose($f);
  $return=array('data'=>$content,
                'pos'=>0,
                'len'=>strlen($content)
               );
return $return;
}
//------------------------------------------------------------------------------
/**
 * loads file from URL and returns its content and length
 * @param $fn - filename
 * @param $login - login name for accessing URL (optional)
 * @param $pass - password for accessing URL (optional)
 */
function load_curl($url,$login='',$pass='') {
  $curl = new Curl;
  //proxy and ignore certificate setup
  $curl->options=array('RETURNTRANSFER' => '1',
                       'PROXY' => 'http://proxy.felk.cvut.cz',
                       'PROXYPORT' => '80',
                       'SSL_VERIFYPEER' => '0'
                      );
  //headers setup
  if($login!='') $curl->headers=array('Authorization'=>'Basic '.base64_encode($login.':'.$pass));
  //get file
  $response = $curl->get($url);
  //write error if any
  if($err=$curl->error()) {
    classification_msg("CURL Error: ".$err);
    }
  //returned structure
  $return=array('data'=>$response->body,
                'pos'=>0,
                'len'=>strlen($response->body)
               );

  unset($curl);
return $return;
}
//------------------------------------------------------------------------------
/**
 * resets actual position in loaded data
 * @param $d - data structure
 */
function reset_pos(&$d) {
$d['pos']=0;
}
//------------------------------------------------------------------------------
/**
 * returns one line (row) of data and updates actual position
 * @param $d - data structure
 */
function get_line(&$d) {
  if(($pos_new=strpos($d['data'],"\n",$d['pos']))===false) $pos_new=$d['len'];
  $pos=$d['pos'];
  $d['pos']=$pos_new+1;
return substr($d['data'],$pos,$pos_new-$pos);
}
//------------------------------------------------------------------------------
/**
 * reads timetable HTML and returns array of links to lectures/practices page
 * @param $d - data structure
 */
function read_timetable($d,$t='cviceni') {
  $time_start=getmicrotime();

  $p['td']='<td(.*)class="'.$t.'"><a ';
  $p['a']='<a(.*)href="(.*)">(.*)</a>((.*) stud.)';

  $mode='td';
  
  while($d['pos']<$d['len']) {
    $x=get_line($d);
    if(ereg($p[$mode],$x,$regs)) {
        //classification_msg('<span style="background: yellow;">'.htmlspecialchars($x).'</span><br />'.$mode.'<pre>'.htmlspecialchars(print_r($regs,true)).'</pre>');
        switch($mode) {
          case 'td':
                 $mode='a';
                 break;
          case 'a':
                 $return[]=$regs[2];
                 $mode='td';
                 break;
        }
     }
    }
  $time_end=getmicrotime();
  $time=$time_end-$time_start;

  //classification_msg($time.'s');
return $return;
}
//------------------------------------------------------------------------------
/**
 * reads student list HTML and returns array of student's properties
 * @param $d - data structure
 */
function read_students($d) {
  $time_start=getmicrotime();

  $p['title']='<title>&nbsp;Paralelka (.*)</title>';
  //$p['td_student']='/studenti/(.*)">(.*)</a></td><td>(.){1,3}/(.){1,3}</td>(<td>&nbsp;</td>){23}<td class="email"><a href="mailto:(.*)">(.*)</a></td>';
  $p['td_student']='/studenti/(.*)">(.*)</a></td><td>(.){1,3}/(.){1,3}</td><td class="email"><a href="mailto:(.*)">(.*)</a></td>';

  $mode='title';

  while($d['pos']<$d['len']) {
    $x=get_line($d);

    if(ereg($p[$mode],$x,$regs)) {
        //classification_msg('<span style="background: yellow;">'.htmlspecialchars($x).'</span><br />'.$mode.'<pre>'.htmlspecialchars(print_r($regs,true)).'</pre>');
        switch($mode) {
          case 'title':
                 $paralelka=$regs[1];
                 $mode='td_student';
                 break;
          }
        }

    if(substr($x,0,27)=='<td class="student-number">') {
      $x=str_replace('<td>&nbsp;</td>','',$x);
      if(ereg($p[$mode],$x,$regs)) {
        //classification_msg('<span style="background: yellow;">'.htmlspecialchars($x).'</span><br />'.$mode.'<pre>'.htmlspecialchars(print_r($regs,true)).'</pre>');
        switch($mode) {
          case 'title':
                 $paralelka=$regs[1];
                 $mode='td_student';
                 break;
          case 'td_student':
                 $return[$regs[6]]=array(
                           'par' => $paralelka,
                           'name' => $regs[2],
                           'login' => $regs[6],
                           'email' => $regs[5]
                           );
                 break;
          }
        }
      }
    }
  $time_end=getmicrotime();
  $time=$time_end-$time_start;

  //classification_msg($time.'s');
return $return;
}
//------------------------------------------------------------------------------
/**
 * reads all students of particular subject
 * @param $url - URL to subject timetable
 * @param $login - login name for accessing URL (optional)
 * @param $pass - password for accessing URL (optional)
 * @param $import_lectures - whether import lectures (practices are always imported)
 */
function get_all_students($url,$login='',$pass='',$import_lectures=true) {
  $time_start=getmicrotime();

  $url_base=substr($url,0,strrpos($url,'/')+1);

  $d=load_curl($url,$login,$pass);
  $practices=read_timetable($d);

  if(!empty($practices))
    foreach($practices as $practice) {
      $d2=load_curl($url_base.$practice,$login,$pass);
      $students=read_students($d2);
      if(!empty($students)) {
        foreach($students as $stlogin=>$student) {
          $all[$stlogin]=array(
          'par_c'=>$student['par'],
          'login'=>$student['login'],
          'name'=>$student['name'],
          'email'=>$student['email']
          );
        }
      }
      else {
        //classification_msg('No student.');
      }
    unset($d2);
    }
    else {
      //classification_msg('No practices.');
    }
  if($import_lectures) {
    reset_pos($d);
    $lectures=read_timetable($d,'prednaska');

    if(!empty($lectures))
      foreach($lectures as $lecture) {
        $d2=load_curl($url_base.$lecture,$login,$pass);
        $students=read_students($d2);
        if(!empty($students)) {
          foreach($students as $stlogin=>$student) {
            if(isset($all[$stlogin])) {
              $all[$stlogin]['par_p']=$student['par'];
            }
            else {
              $all[$stlogin]=array(
              'par_p'=>$student['par'],
              'login'=>$student['login'],
              'name'=>$student['name'],
              'email'=>$student['email']
              );
            }
          }
        }
        else {
          //classification_msg('No student.');
        }
      unset($d2);
      }
    else {
      //classification_msg('No lectures.');
    }
   }

  $time_end=getmicrotime();
  $time=$time_end-$time_start;
  
  if(!is_array($all) || count($all)<=0) return false;

  //classification_msg($time.'s');
return $all;
}
?>